/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*----------------------------------------------------------------------------
 *
 * file   : defines_vol.h
 *
 * Author : Yusuf Attarwala
 * Date   : Sep 93
 *
 *---------------------------------------------------------------------------*/

/* some function pointer typedefs */

typedef void   (*VFPTR)();
typedef long   (*LFPTR)();
typedef long * (*LPFPTR)();
typedef short  (*SFPTR)();
typedef char * (*CFPTR)();

#define _R  0
#define _G  1
#define _B  2

#define _X  0
#define _Y  1
#define _Z  2

#define PROJ_TRANSF 1
#define VIEW_TRANSF 2
#define MODL_TRANSF 3
#define TEXT_TRANSF 4

#define WIREFRAME 1
#define POINT     2
#define TEXTURED  3

#define ANIMATE    0x0010
#define MAXCLIP         6

#define abs(x)   (x<0 ? -(x) : x)
#define SETMIN(b,c) if ((c) <= (b)) (b) = (c);
#define SETMAX(b,c) if ((c) >= (b)) (b) = (c);

#define TEXTURE_2D   2
#define TEXTURE_3D   3
